<template>
	<div>
		<LayoutHeader
			title="Mot de passe"
			:desc="this.descr"
			backlink="Retour"
		/>
		<div class="flex gap-1 column mt-3 pb-2">
			<form id="digit">
				<input ref="number1" :value="number1" type="password" maxlength="1" @keyup="moveOnMax('1')" />
				<input ref="number2" :value="number2" type="password" maxlength="1" @keyup="moveOnMax('2')" />
				<input ref="number3" :value="number3" type="password" maxlength="1" @keyup="moveOnMax('3')" />
				<input ref="number4" :value="number4" type="password" maxlength="1" @keyup="moveOnMax('4')" />
			</form>
		</div>
	</div>
</template>

<script>
import LayoutHeader from '@/components/LayoutHeader';

export default {
	name: 'Password',
	components: { LayoutHeader },
	data: function() {
		return {
			isConfirm: 0,
			savePassword: 0,
			newPassword: 0,
			number1: '',
			number2: '',
			number3: '',
			number4: '',
			descr: "Créer un mot de passe qui vous permertra d'augmenter votre durée d'écran ou de modifier les paramètres."
		};
	},
	methods: {

		setDescription(isLbl) {
			switch (isLbl) {
			case 0 :
				this.descr = "Créer un mot de passe qui vous permertra d'augmenter votre durée d'écran ou de modifier les paramètres.";
				break;
			case 1 :
				this.descr = 'Rentrer de nouveau votre mot de passse.';
				break;
			case 2 :
				this.descr = 'Les deux mots de passe ne sont pas identique. Veuillez recommencer.';
				break;
			case 3 :
				this.descr = 'Votre mot de passe est sauvegardé.';
				break;
			default:
				this.desc = 'Erreur';
			}
		},
		confirmPassword() {
			console.log('confirmPassword');
			console.log('password =' + this.savePassword + '/ newpassword = ' + this.newPassword);
			if (this.savePassword === this.newPassword) {
				this.$router.push('/homepage');
			} else {
				this.setDescription(2);
				this.resetPassword();
			}
		},
		reinitPassword() {
			console.log('reinitPassword');
			this.$refs.number1.value = '';
			this.$refs.number2.value = '';
			this.$refs.number3.value = '';
			this.$refs.number4.value = '';
			this.$refs.number1.focus();
		},
		resetPassword() {
			console.log('resetPassword');
			this.savePassword = null;
			this.newPassword = null;
			this.isConfirm = 0;
			this.reinitPassword();
		},
		moveOnMax(referenceInput) {
			var password;
			switch (referenceInput) {
			case '1':
				if (this.$refs.number1.value.length === 1 && parseFloat(this.$refs.number1.value, 'isNumber') >= 0) {
					this.$refs.number2.focus();
				}
				break;
			case '2':
				if (this.$refs.number2.value.length === 1 && parseFloat(this.$refs.number2.value, 'isNumber') >= 0) {
					this.$refs.number3.focus();
				}
				break;
			case '3':
				if (this.$refs.number3.value.length === 1 && parseFloat(this.$refs.number3.value, 'isNumber') >= 0) {
					this.$refs.number4.focus();
				}
				break;
			case '4':
				if (this.$refs.number4.value.length === 1 && parseFloat(this.$refs.number4.value, 'isNumber') >= 0) {
					this.isConfirm += 1;
					password = this.$refs.number1.value + this.$refs.number2.value + this.$refs.number3.value + this.$refs.number4.value;
					if (this.isConfirm === 1) {
						this.savePassword = password;
						this.reinitPassword();
						this.setDescription(1);
					} else if (this.isConfirm === 2) {
						this.newPassword = password;
						this.confirmPassword();
					}
				}
				break;
			default:
				console.log(this.$refs);
			}
		},
	},
};
</script>

<style lang="scss" scoped>
form{
	text-align: center;
	margin: auto;
}
form#digit input[type=password]{
	height: 50px;
	width: 40px;
	text-align: center;
	font-size: 2em;
	border: 1px solid #000;
	margin: 10px;
}
</style>
